# Set-up caosdb-julialib

The setup of this package consists of first compiling the c++ wrapper
classes in `jlcaosdb` and then installing the Julia package
`CaosDB.jl` itself. Hopefully, the process can be simplified by
providing binary JLL packages in the future.

## Prerequisites

1. Build
   [lbicxxwrap-julia](https://github.com/JuliaInterop/libcxxwrap-julia)
   from source and install it to a location where it is found by cmake
   later on by specifying a `CMAKE_INSTALL_PREFIX` (alternatively, add
   this location to your `CMAKE_PREFIX_PATH`). You may have to create
   an override as explained in the
   [documentation](https://github.com/JuliaInterop/libcxxwrap-julia#using-the-compiled-libcxxwrap-julia-in-cxxwrap)
   of libcxxwrap in order to use the compiled version and not theone
   that is shipped with CxxWrap.jl.
2. In the same way, build and install
   [libcaosdb](https://gitlab.com/caosdb/caosdb-cpplib) in a way that
   it is visible to cmake when compiling the wrapper classes later on.

## Compile jlcaosdb

Compile the wrapper code in `jlcaosdb` by 

```sh
cd jlcaosdb
cmake -B build .
cd build
cmake --build .
```

Depending on your installation of the prerequisites, you may have to
add `-DCMAKE_PREFIX_PATH=/path/to/install/dir` to the first cmake
command. 

**TODO**: Change when we have a JLL binary for jlcaosdb. If you choose
to compile jlcaosdb in another directory than
`caosdb-julialib/jlcaosdb/build` you will have to adapt the path that
is given to the `@wrapmodule` macro(s) in `CaosDB.jl` before using it.

**TODO**: Explain installation (with Pkg.jl), running tests,
dependencies, etc.
